Unit DE22R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, DE20R_p, UTDE10_p;

procedure DE22R(F :Proc_F_DE; M :Integer; XN :Real;
                var YN :Array of Real; XK :Real; HMIN :Real;
                EPS :Real; IORDER :Integer; IU :Integer;
                var H :Real; var Y :Array of Real;
                var YPM :Array of Real; var DELTY :Array of Real;
                var RAB :Array of Real; var IERR :Integer);

implementation

procedure DE22R(F :Proc_F_DE; M :Integer; XN :Real;
                var YN :Array of Real; XK :Real; HMIN :Real;
                EPS :Real; IORDER :Integer; IU :Integer;
                var H :Real; var Y :Array of Real;
                var YPM :Array of Real; var DELTY :Array of Real;
                var RAB :Array of Real; var IERR :Integer);
var
I :Integer;
X,HS,H1 :Real;
BUL :Boolean;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10;
begin
IERR := 0;
for I:=1 to M do
 begin
_1:
  Y[I-1] := YN[I-1];
 end;
if ( XN = XK ) 
 then goto _9;
X := XN;
H := Sign(H,XK-XN);
BUL := False;
if ( IU <> 3 ) 
 then goto _3;
for I:=1 to M do
 begin
_2:
  YPM[I-1] := 1.0;
 end;
goto _5;
_3:
for I:=1 to M do
 begin
_4:
  YPM[I-1] := YN[I-1];
 end;
_5:
I := 0;
_6:
if ( not BUL ) 
 then goto _7;
H := HS;
goto _9;
_7:
H1 := XK-X;
if ( Abs(H1) > Abs(H) ) 
 then goto _8;
HS := H;
BUL := True;
H := H1;
_8:
DE20R(F,M,IORDER,IU,I,HMIN,EPS,X,Y,H,BUL,YPM,
     DELTY,RAB,IERR);
if ( IERR = 1 ) or ( IERR = 0 ) 
 then goto _6;
_9:
if ( IERR = 0 ) 
 then goto _10;
UTDE10(IERR,22);
_10:
end;

end.
